// SPDX-License-Identifier: LGPL-2.1-or-later
// SPDX-FileCopyrightText: 2006 Mathias Froehlich <mathias.froehlich@web.de>

// SGMath 头文件
// 包含了一系列数学相关的头文件

#ifndef SGMath_H
#define SGMath_H

/// Just include them all

#include <iosfwd>

#include "SGMathFwd.hxx"

#include "SGCMath.hxx"	// 引入了std标准数学库
#include "SGLimits.hxx"	// 引入了std标准库的limits头文件，定义了用于SG的limits类
#include "SGMisc.hxx"	// 提供了一系列数学计算函数，包括最大值、最小值、无溢出加法、渐进、幂运算、归一化、四舍五入等
#include "SGGeodesy.hxx"	// 包含了一系列地理计算相关的函数，包括地球参数、坐标转换、距离计算等
#include "SGVec2.hxx"	// 定义了2D向量类SGVec2，提供了向量运算、点积、叉积等操作
#include "SGVec3.hxx"	// 定义了3D向量类SGVec3，提供了向量运算、点积、叉积等操作
#include "SGVec4.hxx"	// 定义了4D向量类SGVec4，提供了向量运算、点积、叉积等操作
#include "SGGeoc.hxx"
#include "SGGeod.hxx"
#include "SGQuat.hxx"
#include "SGLocation.hxx"
#include "SGMatrix.hxx"

#endif
